-- Function: zz_mask4item(text)
-- For EUC-JP !! http://kazpgm.ddo.jp/ NewBSD

-- DROP FUNCTION zz_mask4item(text);

CREATE OR REPLACE FUNCTION zz_mask4item(text)
  RETURNS text AS
$BODY$

DECLARE
strItem ALIAS FOR $1;
str TEXT;
strsub TEXT;
i integer;

BEGIN

if strItem is null then
    return null;
end if;

str := '';
strsub := '';

for i in 1..length(strItem) loop
	if mod(i,2) = 1 then
		str := str || substr(strItem,i,1);
	else
		strsub = substr(strItem,i,1);
		if strsub >= '' AND strsub <= '' then
			str := str || '';
		elseif strsub >= '' AND strsub <= '' then
			str := str || '';
		elseif strsub >= '' AND strsub <= '' then
			str := str || '';
		elseif strsub >= '' AND strsub <= '' then
			str := str || '';
		elseif strsub >= '' AND strsub <= '' then
			str := str || '';
		elseif strsub = '' OR strsub = '' then
			str := str || strsub;
		elseif strsub >= '' AND strsub <= '' then
			str := str || '';
		elseif strsub > '' then
			str := str || '';
		elseif strsub >= '0' AND strsub <= '9' then 
			str := str || '9';
		elseif strsub >= 'A' AND strsub <= 'Z' then 
			str := str || 'X';
		elseif strsub >= 'a' AND strsub <= 'z' then 
			str := str || 'x';
		elseif ascii(strsub) < 255 then
			if strsub = '-' OR strsub = '.' OR strsub = '@' OR strsub = ' '  then 
				str := str || strsub;
			else
				str := str || 'X';
			end if;
		else
		end if;
	end if;
end loop;

return str;

END;

$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION zz_mask4item(text) OWNER TO postgres;
